/*
  fablabway.com
  file:         som_lab_7700.ino
  project:     lab52 - capacimeter - capacino
  description:  capacimeter
  author:       Mauro Rossolato
  licence:      Creative Commons BY-NC-ND
  when        who   what
  -----------------------------------
  19.05.2016  mr    creates
  17.08.2021  mr    beat only when palyers are more then one
  17.08.2021  MR    start clear the previous led
  18.08.2021  mr    flashing led when beat   som_lab_7707
  
*/

// ONLY PWM CHANNELS
#define MPINLED1  	11
#define MPINLED2  	10
#define MPINLED3  	9
#define MPINLED4  	6

#define MPINTONE  	5

#define MPINRUN1  	13
#define MPINRUN2  	12
#define MPINRUN3  	8
#define MPINRUN4  	7

// #define MPINWHO1  	3
// #define MPINWHO2  	2
#define MPINSTART  	3
#define MPINRESET  	2

/*
#define MPINSTART  	A1
#define MPINRESET  	A0        // ANALOG MPINRD
#define MPINOUT  	A2        // ANALOG MPINOUT 
*/

// literal kostants
#define MPGMID "FLW,2018 - lab52 - capacimetro digitale capacino, v.1.0"

// global vars
int wlevled;
int wneedsval;
byte  wregister;
 int wnumplayer;
//int wnumplayer;
const float wpumpcap = 24.48;        // capacita' interna, in pFarad 
const float wcapgnd  = wpumpcap;    //  wcapgnd
const float wrespull = 34.8;        //  resistenze di "pull-up", in ohm
const int wmaxvaladc = 1023;        // max-values del convertitore adc
int wmelody[] = {   262,294,330,349,392,440,494,523 };
unsigned long wtimerbeat;
// objects
//RTC_DS1307 RTC;

/*
quando è nello stato in attesa di start è attiva la funzione di lettura 
del numero di canali.
questa chg permette di ridurre il numero di canali di input
e di eliminare il selettore per il numero di concorrenti.
*/



void setup()
{
  pinMode(MPINLED1, OUTPUT);  
  pinMode(MPINLED2, OUTPUT);  
  pinMode(MPINLED3, OUTPUT);  
  pinMode(MPINLED4, OUTPUT);  
  
  pinMode(MPINTONE, OUTPUT);  

  pinMode(MPINRUN1, INPUT);  
  pinMode(MPINRUN2, INPUT);  
  pinMode(MPINRUN3, INPUT);  
  pinMode(MPINRUN4, INPUT);  

  // pinMode(MPINWHO1, INPUT);  
  // pinMode(MPINWHO2, INPUT);    

  pinMode(MPINSTART, INPUT);    
  pinMode(MPINRESET, INPUT);    

  digitalWrite(MPINLED1, LOW);        
  digitalWrite(MPINLED2, LOW);   
  digitalWrite(MPINLED3, LOW);   
  digitalWrite(MPINLED4, LOW); 
  
  Serial.begin(9600);                  // inizializza la seriale
  Serial.println(MPGMID);              // invio il nome programma
  wneedsval = 0;                      // registro per invio dati a seriale
    wregister =0;
    wtimerbeat = millis();
}

/*
0 = RESET PRESSED
1 = START RUNNING (AFTER PRESSING). se =0 allora attiva conteggio concorrenti
2 = clock-beat
3 = esiste concorrente 1
4 = esiste concorrente 2
5 = esiste concorrente 3
6 = esiste concorrente 4

*/
void loop() {
int wpress;  
// var001
if  (bitRead(wregister, 1) == HIGH ) pwaitans();
wpress = phaspressed();
// var002
if  ((bitRead(wregister, 1) == HIGH ) && (wpress>0)) { 
  bitWrite(wregister,1,0);
  piknow();
  piknowled(wpress);
  }
//  if (wpress>0) 
if  (bitRead(wregister, 1) == LOW ) wnumplayer=phasplayer();
// 17.08.2021 if ((digitalRead(MPINSTART)== HIGH) && (bitRead(wregister, 1) == LOW)) bitWrite(wregister,1,1);
if (((digitalRead(MPINSTART)== HIGH) && (wnumplayer>1)) && (bitRead(wregister, 1) == LOW)) {
  wtimerbeat = millis();
  bitWrite(wregister,1,1);
  digitalWrite(MPINLED1,LOW);
  digitalWrite(MPINLED2,LOW);
  digitalWrite(MPINLED3,LOW);
  digitalWrite(MPINLED4,LOW);
  }
if (digitalRead(MPINRESET)== HIGH) wregister=0;   
pdumpregister();
delay(5);
}


/* ============================================== */  
void pdumpregister ( void ) {
  Serial.print("register ");
  Serial.print(bitRead(wregister,7));
  Serial.print(bitRead(wregister,6));
  Serial.print(bitRead(wregister,5));
  Serial.print(bitRead(wregister,4));
  Serial.print(bitRead(wregister,3));
  Serial.print(bitRead(wregister,2));
  Serial.print(bitRead(wregister,1));
  Serial.println(bitRead(wregister,0));  
  }

/* ============================================== */  
/* when pressed for answer */  
  void piknow( void) {
    for (int wndx = 0; wndx < 8; wndx++) {
    tone(MPINTONE,wmelody[wndx],100); 
    delay(50);
    noTone(MPINTONE);
    }
}

void piknowled (int pchannel) {
  if (pchannel == 1) digitalWrite(MPINLED1,HIGH);
  else digitalWrite(MPINLED1,LOW);
  if (pchannel == 2) digitalWrite(MPINLED2,HIGH);
  else digitalWrite(MPINLED2,LOW);

  }

/* ============================================== */  
/* waiting for answer */  
void pwaitans( void) {
//    for (int wndx = 0; wndx < 4; wndx++) {
//    tone(MPINTONE,wmelody[8-wndx],100); 
Serial.print("timer: ");
Serial.println(millis()-wtimerbeat);
/*if (
(
(millis()-wtimerbeat)
% 
1000
)
<10)*/
if ((millis()-wtimerbeat)>1000){
  tone(MPINTONE,wmelody[4],500);
  wtimerbeat=millis();
    digitalWrite(MPINLED1,LOW);
  digitalWrite(MPINLED2,LOW);
  digitalWrite(MPINLED3,LOW);
  digitalWrite(MPINLED4,LOW);
      digitalWrite(MPINLED1,HIGH);
  digitalWrite(MPINLED2,HIGH);
  digitalWrite(MPINLED3,HIGH);
  digitalWrite(MPINLED4,HIGH);
  delay(200);
digitalWrite(MPINLED1,LOW);
  digitalWrite(MPINLED2,LOW);
  digitalWrite(MPINLED3,LOW);
  digitalWrite(MPINLED4,LOW);

  }
  
//    delay(100);
//    noTone(MPINTONE);
    
}

/* ============================================== */  
/* waiting for answer */  
int phaspressed( void) {
    if (digitalRead(MPINRUN1)== HIGH) return 1;
    if (digitalRead(MPINRUN2)== HIGH) return 2;
     if (digitalRead(MPINRUN3)== HIGH) return 3;
      if (digitalRead(MPINRUN4)== HIGH) return 4;
      return 0;
}


/* ============================================== */  
/* waiting for answer */  
int phasplayer( void) {
  int wnumplayer;
  if ((digitalRead(MPINRUN1)== HIGH) && (phaspressed()==1)) bitWrite(wregister,3,1);
  if ((digitalRead(MPINRUN2)== HIGH) && (phaspressed()==2)) bitWrite(wregister,4,1);
  if ((digitalRead(MPINRUN3)== HIGH) && (phaspressed()==3)) bitWrite(wregister,5,1);
  if ((digitalRead(MPINRUN4)== HIGH) && (phaspressed()==4)) bitWrite(wregister,6,1);
  wnumplayer = bitRead(wregister,3)+bitRead(wregister,4)+bitRead(wregister,5)+bitRead(wregister,6);
  Serial.print("wnumplayer: ");
  Serial.println(wnumplayer); 
  return (wnumplayer);
}
